Files seq24-rev48 adding win32/src/0004.s24 and seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/0004.s24 differ
diff -rupN seq24-rev48 adding win32/src/config.h seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/config.h
--- seq24-rev48 adding win32/src/config.h	2009-05-20 20:54:39.640625000 -0500
+++ seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/config.h	2009-05-20 20:54:47.156250000 -0500
@@ -36,7 +36,7 @@
 #define STDC_HEADERS 1
 
 /* Version number of package */
-#define VERSION "0.9.0-win32-beta-1"
+#define VERSION "0.9.0-win32-beta-4"
 
 /* gnu source */
 #define _GNU_SOURCE 1
diff -rupN seq24-rev48 adding win32/src/config_win32.h seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/config_win32.h
--- seq24-rev48 adding win32/src/config_win32.h	2009-05-20 20:54:57.171875000 -0500
+++ seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/config_win32.h	2009-05-20 20:30:54.484375000 -0500
@@ -36,7 +36,7 @@
 #define STDC_HEADERS 1
 
 /* Version number of package */
-#define VERSION "0.9.0-win32-beta-1"
+#define VERSION "0.9.0-win32-beta-4"
 
 /* gnu source */
 #define _GNU_SOURCE 1
diff -rupN seq24-rev48 adding win32/src/globals.h seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/globals.h
--- seq24-rev48 adding win32/src/globals.h	2009-05-20 20:30:46.046875000 -0500
+++ seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/globals.h	2009-05-20 20:30:54.656250000 -0500
@@ -26,6 +26,9 @@
 #include <string>
 #include <gtkmm/main.h>
 #include <gtkmm/drawingarea.h>
+//For keys
+#include <gtkmm/accelkey.h>
+
 
 using namespace std;
 
@@ -33,6 +36,7 @@ using namespace std;
 const int c_mainwnd_rows = 4;
 const int c_mainwnd_cols = 8;
 const int c_seqs_in_set = c_mainwnd_rows * c_mainwnd_cols;
+const int c_gmute_tracks = c_seqs_in_set * c_seqs_in_set;
 const int c_max_sets = 32;
 const int c_total_seqs = c_seqs_in_set * c_max_sets;
 
@@ -127,8 +131,11 @@ const int c_normal = 1;
 const int c_paste  = 2;
 
 /* redraw when recording ms */
+#ifdef __WIN32__
+const int c_redraw_ms = 20;
+#else
 const int c_redraw_ms = 40;
-
+#endif
 
 /* consts for perform editor */
 const int c_names_x = 6 * 24;
@@ -296,5 +303,27 @@ enum mouse_action_e 
     e_action_grow
 };
 
+enum interaction_method_e
+{
+    e_seq24_interaction,
+    e_fruity_interaction,
+    e_number_of_interactions // keep this one last...
+};
+const char* const c_interaction_method_names[] =
+{
+    "seq24",
+    "fruity",
+    NULL
+};
+const char* const c_interaction_method_descs[] =
+{
+    "original seq24 method",
+    "similar to a certain fruity sequencer we like",
+    NULL
+};
+extern interaction_method_e global_interactionmethod;
 
+// makes printable text from the given key
+// see seq24.cpp for implementation
+char* key2text( unsigned long int val );
 #endif
diff -rupN seq24-rev48 adding win32/src/learn.xpm seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/learn.xpm
--- seq24-rev48 adding win32/src/learn.xpm	1969-12-31 18:00:00.000000000 -0600
+++ seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/learn.xpm	2009-05-15 00:59:02.878612000 -0500
@@ -0,0 +1,14 @@
+/* XPM */
+static const char * learn_xpm[] = {
+"21 6 5 1",
+" 	c None",
+".	c #000000",
+"+	c #FFC1C1",
+"@	c #AD6666",
+"#	c #724B4B",
+"     ..              ",
+"     ..              ",
+"     ..              ",
+"     ..              ",
+"     ............    ",
+"     ............    "};
diff -rupN seq24-rev48 adding win32/src/learn2.xpm seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/learn2.xpm
--- seq24-rev48 adding win32/src/learn2.xpm	1969-12-31 18:00:00.000000000 -0600
+++ seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/learn2.xpm	2009-05-15 00:59:02.878612000 -0500
@@ -0,0 +1,14 @@
+/* XPM */
+static const char * learn2_xpm[] = {
+"21 6 5 1",
+". 	c None",
+"   c #000000",
+"+	c #FFC1C1",
+"@	c #AD6666",
+"#	c #724B4B",
+"     ..              ",
+"     ..              ",
+"     ..              ",
+"     ..              ",
+"     ............    ",
+"     ............    "};
diff -rupN seq24-rev48 adding win32/src/mainwid.cpp seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/mainwid.cpp
--- seq24-rev48 adding win32/src/mainwid.cpp	2009-05-20 20:30:46.156250000 -0500
+++ seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/mainwid.cpp	2009-05-20 20:30:54.781250000 -0500
@@ -210,12 +210,23 @@ mainwid::draw_sequence_on_pixmap( int a_
 		/*char key =  m_seq_to_char[local_seq];*/
 
 	    char str[20];
-	    sprintf( str, 
+
+        if (m_mainperf->show_ui_sequence_key())
+        {
+    	    sprintf( str, "%c", (char)m_mainperf->lookup_keyevent_key( a_seq ) );
+
+    	    p_font_renderer->render_string_on_drawable(m_gc,
+                                                       base_x + c_seqarea_x - 7,
+                                                       base_y + c_text_y * 4 - 2,
+                                                       m_pixmap, str, col );
+        }
+
+	    sprintf( str,
 		     "%d-%d %ld/%ld",
 		     seq->get_midi_bus(), 
 		     seq->get_midi_channel()+1,
 		     seq->get_bpm(), seq->get_bw() );
-        
+
 	    p_font_renderer->render_string_on_drawable(m_gc,
                                                    base_x + c_text_x, 
                                                    base_y + c_text_y * 4 - 2,
diff -rupN seq24-rev48 adding win32/src/mainwnd.cpp seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/mainwnd.cpp
--- seq24-rev48 adding win32/src/mainwnd.cpp	2009-05-20 20:30:46.234375000 -0500
+++ seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/mainwnd.cpp	2009-05-20 20:30:54.859375000 -0500
@@ -28,22 +28,37 @@
 
 #include "play2.xpm"
 #include "stop.xpm"
+#include "learn.xpm"
+#include "learn2.xpm"
 #include "perfedit.xpm"
 #include "seq24.xpm"
 #include "seq24_32.xpm"
 
 bool is_pattern_playing = false;
 
+// tooltip helper, for old vs new gtk...
+#if GTK_MINOR_VERSION >= 12
+#   define add_tooltip( obj, text ) obj->set_tooltip_text( text);
+#else
+#   define add_tooltip( obj, text ) m_tooltips->set_tip( *obj, text );
+#endif
+
 mainwnd::mainwnd(perform *a_p)
 {
     set_icon(Gdk::Pixbuf::create_from_xpm_data(seq24_32_xpm));
 
     /* set the performance */
     m_mainperf = a_p;
+    
+    /* register for notification */
+    m_mainperf->m_notify.push_back( this );
 
     /* main window */
     update_window_title();
 
+#if GTK_MINOR_VERSION < 12
+    m_tooltips = manage( new Tooltips() );
+#endif
     m_main_wid = manage( new mainwid( m_mainperf ));
     m_main_time = manage( new maintime( ));
 
@@ -99,9 +114,7 @@ mainwnd::mainwnd(perform *a_p)
                     Gdk::Pixbuf::create_from_xpm_data( stop_xpm ))));
     m_button_stop->signal_clicked().connect(
             mem_fun(*this, &mainwnd::stop_playing));
-#if GTK_MINOR_VERSION >= 12
-    m_button_stop->set_tooltip_text("Stop playing MIDI sequence");
-#endif
+    add_tooltip( m_button_stop, "Stop playing MIDI sequence" );
     hbox->pack_start(*m_button_stop, false, false);
 
     /* play button */
@@ -110,9 +123,7 @@ mainwnd::mainwnd(perform *a_p)
                     Gdk::Pixbuf::create_from_xpm_data( play2_xpm ))));
     m_button_play->signal_clicked().connect(
             mem_fun( *this, &mainwnd::start_playing));
-#if GTK_MINOR_VERSION >= 12
-    m_button_play->set_tooltip_text("Play MIDI sequence");
-#endif
+    add_tooltip( m_button_play, "Play MIDI sequence" );
     hbox->pack_start(*m_button_play, false, false);
 
     /* song edit button */
@@ -121,9 +132,7 @@ mainwnd::mainwnd(perform *a_p)
                     Gdk::Pixbuf::create_from_xpm_data( perfedit_xpm  ))));
     m_button_perfedit->signal_clicked().connect(
             mem_fun( *this, &mainwnd::open_performance_edit ));
-#if GTK_MINOR_VERSION >= 12
-    m_button_perfedit->set_tooltip_text("Show or hide song editor window");
-#endif
+    add_tooltip( m_button_perfedit, "Show or hide song editor window" );
     hbox->pack_end(*m_button_perfedit, false, false, 4);
 
     /* bpm spin button */
@@ -132,9 +141,7 @@ mainwnd::mainwnd(perform *a_p)
     m_spinbutton_bpm->set_editable( false );
     m_adjust_bpm->signal_value_changed().connect(
             mem_fun(*this, &mainwnd::adj_callback_bpm ));
-#if GTK_MINOR_VERSION >= 12
-    m_spinbutton_bpm->set_tooltip_text("Adjust beats per minute (BPM) value");
-#endif
+    add_tooltip( m_spinbutton_bpm, "Adjust beats per minute (BPM) value" );
     hbox->pack_start(*(manage( new Label( "  bpm " ))), false, false, 4);
     hbox->pack_start(*m_spinbutton_bpm, false, false );
   
@@ -145,9 +152,7 @@ mainwnd::mainwnd(perform *a_p)
     m_spinbutton_ss->set_wrap( true );
     m_adjust_ss->signal_value_changed().connect(
             mem_fun(*this, &mainwnd::adj_callback_ss ));
-#if GTK_MINOR_VERSION >= 12
-    m_spinbutton_ss->set_tooltip_text("Select sreen set");
-#endif
+    add_tooltip( m_spinbutton_ss, "Select sreen set" );
     hbox->pack_end(*m_spinbutton_ss, false, false );
     hbox->pack_end(*(manage( new Label( "  set " ))), false, false, 4);
  
@@ -157,9 +162,7 @@ mainwnd::mainwnd(perform *a_p)
             mem_fun(*this, &mainwnd::edit_callback_notepad));
     m_entry_notes->set_text(*m_mainperf->get_screen_set_notepad(
                 m_mainperf->get_screenset())); 
-#if GTK_MINOR_VERSION >= 12
-    m_entry_notes->set_tooltip_text("Enter screen set name");
-#endif
+    add_tooltip( m_entry_notes, "Enter screen set name" );
     hbox->pack_start( *m_entry_notes, true, true );
 
 
@@ -168,7 +171,34 @@ mainwnd::mainwnd(perform *a_p)
     hbox2->pack_start(*manage(new Image(
                     Gdk::Pixbuf::create_from_xpm_data(seq24_xpm))),
             false, false);
-    hbox2->pack_end( *m_main_time, false, false );
+
+    // adjust placement...
+    VBox *vbox_b = manage( new VBox() );
+    HBox *hbox3 = manage( new HBox( false, 0 ) );
+    vbox_b->pack_start( *hbox3, false, false );
+    hbox2->pack_end( *vbox_b, false, false );
+    hbox3->set_spacing( 10 );
+
+    /* timeline */
+    hbox3->pack_start( *m_main_time, false, false );
+
+    /* group learn button */
+    m_button_learn = manage( new Button( ));
+    m_button_learn->set_focus_on_click( false );
+    m_button_learn->set_flags( m_button_learn->get_flags() & ~Gtk::CAN_FOCUS );
+    m_button_learn->set_image(*manage(new Image(
+                    Gdk::Pixbuf::create_from_xpm_data( learn_xpm ))));
+    m_button_learn->signal_clicked().connect(
+            mem_fun(*this, &mainwnd::learn_toggle));
+    add_tooltip( m_button_learn, "Mute Group Learn\n\n"
+            "Click 'L' then press a mutegroup key to store the mute state of "
+            "the sequences in that key.\n\n"
+            "(see File/Options/Keyboard for available mutegroup keys "
+            "and the corresponding hotkey for the 'L' button)" );
+    hbox3->pack_end( *m_button_learn, false, false );
+
+    Button w;
+    hbox3->set_focus_child( w ); // clear the focus, don't want to trigger L via keys
 
     /* set up a vbox, put the menu in it, and add it */
     VBox *vbox = new VBox();
@@ -278,6 +308,28 @@ mainwnd::stop_playing( void )
     is_pattern_playing = false;
 }
 
+void
+mainwnd::on_grouplearnchange(bool state)
+{
+    /* respond to learn mode change from m_mainperf */
+    m_button_learn->set_image(*manage(new Image(
+        Gdk::Pixbuf::create_from_xpm_data( state ? learn2_xpm : learn_xpm))));
+}
+
+void
+mainwnd::learn_toggle()
+{
+    if (m_mainperf->is_group_learning())
+    {
+        m_mainperf->unset_mode_group_learn();
+    }
+    else
+    {
+        m_mainperf->set_mode_group_learn();
+    }
+}
+
+
 
 /* callback function */
 void mainwnd::file_new()
@@ -631,7 +683,8 @@ mainwnd::about_dialog( void )
     dialog.set_transient_for(*this);
     dialog.set_name(PACKAGE_NAME);
     dialog.set_version(PACKAGE_VERSION);
-    dialog.set_comments("Interactive MIDI Sequencer");
+    dialog.set_comments("Interactive MIDI Sequencer\n"
+                        VERSION);
 
     dialog.set_copyright(
             "(C) 2002 - 2006 Rob C. Buse\n"
@@ -649,6 +702,7 @@ mainwnd::about_dialog( void )
     list_authors.push_back("Peter Leigh <pete.leigh@gmail.com>");
     list_authors.push_back("Anthony Green <green@redhat.com>");
     list_authors.push_back("Daniel Ellis <mail@danellis.co.uk>");
+    list_authors.push_back("Kevin Meinert <kevin@subatomicglue.com>");
     dialog.set_authors(list_authors);
 
     std::list<Glib::ustring> list_documenters;
@@ -691,6 +745,9 @@ mainwnd::on_key_release_event(GdkEventKe
     if ( a_ev->keyval == m_mainperf->m_key_snapshot_1 ||
             a_ev->keyval == m_mainperf->m_key_snapshot_2 )
         m_mainperf->unset_sequence_control_status( c_status_snapshot );
+    if ( a_ev->keyval == m_mainperf->m_key_group_learn ){
+        m_mainperf->unset_mode_group_learn();
+    }
 
     return false;
 }
@@ -711,10 +768,10 @@ mainwnd::on_key_press_event(GdkEventKey*
 {
     // control and modifier key combinations matching
     // menu items have first priority
-    if (Gtk::Window::on_key_press_event(a_ev))
-        return true;
+    /*if (*/Gtk::Window::on_key_press_event(a_ev);
+        //return true;  // on win32, it'd always return true here (i.e. for SPACE bar)... ?
 
-    else if ( m_entry_notes->has_focus()) {
+    /*else */if ( m_entry_notes->has_focus()) {
         m_entry_notes->event( (GdkEvent*) a_ev );
         return false;
     }
@@ -722,7 +779,8 @@ mainwnd::on_key_press_event(GdkEventKey*
         if ( a_ev->type == GDK_KEY_PRESS ){
 
             if ( global_print_keys ){
-                printf( "key_press[%d]\n", a_ev->keyval ); 
+                printf( "key_press[%d]\n", a_ev->keyval );
+                fflush( stdout );
             }
             
             if ( a_ev->keyval == m_mainperf->m_key_bpm_dn ){
@@ -740,7 +798,8 @@ mainwnd::on_key_press_event(GdkEventKey*
                 m_mainperf->set_sequence_control_status( c_status_replace );
             }
             
-            if (a_ev->keyval ==  m_mainperf->m_key_queue )
+              if ((a_ev->keyval ==  m_mainperf->m_key_queue )
+             || (a_ev->keyval == m_mainperf->m_key_keep_queue ))
             {
                 m_mainperf->set_sequence_control_status( c_status_queue );
             }
@@ -766,23 +825,79 @@ mainwnd::on_key_press_event(GdkEventKey*
                 m_adjust_ss->set_value( m_mainperf->get_screenset()  );	
                 m_entry_notes->set_text( * m_mainperf->get_screen_set_notepad(m_mainperf->get_screenset()  )); 
             }
-            
-            if ( a_ev->keyval == m_mainperf->m_key_start )
+             if ( a_ev->keyval == m_mainperf->m_key_set_playing_screenset ){
+                m_mainperf->set_playing_screenset();
+            }
+           
+            if ( a_ev->keyval == m_mainperf->m_key_group_on ){
+                m_mainperf->set_mode_group_mute();
+            }
+            if ( a_ev->keyval == m_mainperf->m_key_group_off ){
+                m_mainperf->unset_mode_group_mute();
+            }
+           
+            if ( a_ev->keyval == m_mainperf->m_key_group_learn ){
+                m_mainperf->set_mode_group_learn();
+            }
+
+            // activate mute group key
+            if( m_mainperf->get_key_groups()->count( a_ev->keyval ) != 0 )
             {
-                if (is_pattern_playing)
-                    stop_playing();
-                else
-                    start_playing();
+                m_mainperf->select_and_mute_group( m_mainperf->lookup_keygroup_group( a_ev->keyval ) );
             }
 
+            // mute group learn
+            if (m_mainperf->is_learn_mode() &&
+                a_ev->keyval != m_mainperf->m_key_group_learn)
+            {
+                if( m_mainperf->get_key_groups()->count( a_ev->keyval ) != 0 )
+                {
+                    char buf[512];
+                    sprintf( buf, "Midi Group Learn: Learned! key:%s (code:%d) "
+                                  "mapped", key2text( a_ev->keyval ), a_ev->keyval );
+                    Gtk::MessageDialog dialog(*this,
+                           buf, false,
+                           Gtk::MESSAGE_QUESTION, Gtk::BUTTONS_OK, true);
+                    dialog.run();
+                    
+                    // we miss the keyup msg for learn, force set it off
+                    m_mainperf->unset_mode_group_learn();
+                }
+                else
+                {
+                    char buf[512];
+                    sprintf( buf, "Midi Group Learn: key:%s (code:%d) not "
+                                  "one of the configured mute-group keys, to change "
+                                  "see file/options menu or .seq24rc",
+                                  key2text( a_ev->keyval ), a_ev->keyval );
+                    Gtk::MessageDialog errdialog(*this, buf, false,
+                           Gtk::MESSAGE_ERROR, Gtk::BUTTONS_OK, true);
+                    errdialog.run();
+                    // we miss the keyup msg for learn, force set it
+                    m_mainperf->unset_mode_group_learn();
+                }
+            }
+
+            // the start/end key may be the same key (i.e. SPACE)
+            // allow toggling when the same key is mapped to both triggers (i.e. SPACEBAR)
+            bool dont_toggle = m_mainperf->m_key_start != m_mainperf->m_key_stop;
+            if ( a_ev->keyval == m_mainperf->m_key_start && (dont_toggle || !is_pattern_playing))
+            {
+                start_playing();
+            }
+            else if ( a_ev->keyval == m_mainperf->m_key_stop && (dont_toggle || is_pattern_playing))
+            {
+                stop_playing();
+            }
 
+            /* toggle sequence mute/unmute using keyboard keys... */
             if( m_mainperf->get_key_events()->count( a_ev->keyval) != 0 ){
-                
-                sequence_key(  (*m_mainperf->get_key_events())[a_ev->keyval] );
+
+                sequence_key( m_mainperf->lookup_keyevent_seq( a_ev->keyval ) );
             }
         }
     }
-    
+
     return false;
 }
 
diff -rupN seq24-rev48 adding win32/src/mainwnd.h seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/mainwnd.h
--- seq24-rev48 adding win32/src/mainwnd.h	2009-05-20 20:30:46.250000000 -0500
+++ seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/mainwnd.h	2009-05-20 20:30:54.875000000 -0500
@@ -47,13 +47,18 @@ using namespace Gtk;
 using namespace Menu_Helpers;
 
 
-class mainwnd : public Gtk::Window
+class mainwnd : public Gtk::Window, public performcallback
 {
-   
+    /* notification handler for learn mode toggle */
+    virtual void on_grouplearnchange(bool state);
+
  private:
 
     bool      m_modified;
     
+#if GTK_MINOR_VERSION < 12
+    Tooltips *m_tooltips;
+#endif
     MenuBar  *m_menubar;
     Menu     *m_menu_file;
     Menu     *m_menu_view;
@@ -69,6 +74,8 @@ class mainwnd : public Gtk::Window
 
     Gdk::Cursor   m_main_cursor;
     
+    Button      *m_button_learn;
+
     Button      *m_button_stop;
     Button      *m_button_play;
     Button      *m_button_perfedit;
@@ -97,6 +104,7 @@ class mainwnd : public Gtk::Window
 
     void start_playing();
     void stop_playing();
+    void learn_toggle();
     void open_performance_edit( );
     void sequence_key( int a_seq );
     void update_window_title();
